#! /bin/perl

#
# Eric GARREAU, 1997
# BPL (Bob Public License) : register to the Mailing List of this product
# 'Le Petit Bob' at 'egarreau@free.fr'
#

#
# Avis au lecteur : merci d'etre indulgent, c'est mon premier jour de Perl...
#

#
# bon, d'accord : ces fichiers ont evolue, depuis mon premier jour de Perl...
#

require 5;


#
# deuxieme passe : reperer tout ce qui releve de la mise en forme :
#  - detecter les paragraphes
#  - mettre en caracteres gras
#  - mettre en italiques
#  - detecter les points d'ancrage (anchors)
#  - detecter les "grosses separations" et inserer des '<br>'
#


$pass2Debug=0;

# show tags in the resulting substitution
# - 1 : "bob" --> <i>"bob"</i>
# - 0 : "bob" --> <i>bob</i>
$showTagsForBold=0;
$showTagsForItalic=0;
$showTagsForUnderline=0;
$showTagsForAnchor=0;


# la gestion des paragraphes se fait en cherchant DEUX newlines ($/="\n\n"),
# afin de "coller" les lignes qui se suivent dans le meme paragraphe
$/="\n\n";

while ($_ = <>)
{
    # inserer un BREAK '<br>' si on a beaucoup de caracteres RETURN
    # la loi est : nb_BR = int((nb_RETURN - 2) / 2)
    $_ = '<br>' if($_ eq "\n\n");


    # NOTE : le 's//g' ne sait pas explorer TOUTES les paires dans les chaines
    
    # mettre en GRAS les termes informatiques (entre '...')
    # d'abord, tous les cas simples...
    if($showTagsForBold > 0)
    {
	s/^'([\S\.\/][^\',]*[\S\/]*)'([\<\n\)\.!, ])/ '<b>$1<\/b>'$2/g;
	s/([\s\(])'([\S\.\/][^\',]*[\S\/]*)'([\<\n\)\.!, ])/$1'<b>$2<\/b>'$3/g;
    }
    else
    {
	s/^'([\S\.\/][^\',]*[\S\/]*)'([\<\n\)\.!, ])/ <b>$1<\/b>$2/g;
	s/([\s\(])'([\S\.\/][^\',]*[\S\/]*)'([\<\n\)\.!, ])/$1<b>$2<\/b>$3/g;
    }
    print STDERR "[$_]\n" if $pass2Debug > 5;

    # puis les mots qui contiennent un (') entre '...'
    ###s/\s'([\w ]+\'[\w ]+)'/ '<b>$1<\/b>'/g;
    if($showTagsForBold > 0)
    {
	s/\s'(\w[\w -\>]*\'[^\',]+)'/ '<b>$1<\/b>'/g;
    }
    else
    {
	s/\s'(\w[\w -\>]*\'[^\',]+)'/ <b>$1<\/b>/g;
    }
    print STDERR "[$_]\n\n" if $pass2Debug > 5;
    
    # mettre en italiques les termes du jargon ou des citations (entre "...")
    # (la plage de caracteres '\xC0' a '\xFF' correspond a la plage ISO-8859
    #  des caracteres accentues reconnus par un navigateur HTML)
    # (cf: html_sp) (dans la doc Brighton)
    if($showTagsForItalic > 0)
    {
	# ARG : comment faire un 's///' recursif quand 's///g' echoue ??? 
	while(s/([\s.])\&quot\;([\<\>\(\)\w\s\'\`\xc0-\xff]+)\&quot\;([\s.\,])/$1\&quot\;<i>$2<\/i>\&quot\;$3/)
	{
	};
    }
    else
    {
	# ARG : comment faire un 's///' recursif quand 's///g' echoue ??? 
	while(s/([\s.])\&quot\;([\<\>\(\)\w\s\'\`\xc0\-\xff]+)\&quot\;([\s.\,])/$1<i>$2<\/i>$3/)
	{
	};
    }
    
    # declarer un ancrage pour les termes indiques entre '[[' et ']]'
    if($showTagsForAnchor > 0)
    {
	# danger : comment empecher le 'while()' de boucler ???
	s/\[\[([^.\n\]\;]+)\]\]/<a name=\"$1\">\[\[$1\]\]/;
    }
    else
    {
	while(s/\[\[([^\n\]\;]+)\]\]/<a name=\"$1\">$1/) {};
    }
 
   
#    if($showTagsForUnderline > 0)

    
    # ajouter le tag paragraphe a chaque 'paquet' separe par deux NEWLINEs
    print "$_<p>";
};

